﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Net;
using System.Text;
using System.IO;
using Newtonsoft.Json;

namespace CSharpSampleProject
{
    public partial class Client : System.Web.UI.Page
    {
        string CreateClientUrl = "https://jobapi.tasq.com.au/api/Job/CreateClient";
        string EditClientUrl = "https://jobapi.tasq.com.au/api/Job/EditClient";
        string DeleteClientUrl = "https://jobapi.tasq.com.au/api/Job/DeleteClient";
        string GetClientListUrl = "https://jobapi.tasq.com.au/api/Job/GetClientList?Jsonlogin={\"LoginName\":\"testapi@tasq.com.au\",\"ClientIP\":null,\"Password\":\"test123.\",\"MobileDeviceToken\":null,\"WebApiTOKEN\":\"b3b777b0-c7af-458d-be64-b3d6d760177f\"}&SearchText=&IsLoadInactive=NO&PageSize=30&PageIndex=1";
        string ImportClientUrl = "https://jobapi.tasq.com.au/api/Job/ImportClient";

        string CreateClientContent = "{\"CompanyValidateInfo\":{\"LoginName\":\"testapi@tasq.com.au\",\"ClientIP\":null,\"Password\":\"test123.\",\"MobileDeviceToken\":null,\"WebApiTOKEN\":\"b3b777b0-c7af-458d-be64-b3d6d760177f\"},\"Client\":{\"ClientID\":null,\"ClientName\":\"AZ_1\",\"JobContactTitle\":\"Mr\",\"JobContactFirstName\":\"aaa\",\"JobContactLastName\":\"vvv\",\"JobContactPhone\":\"15465656663\",\"JobContactMobile\":\"\",\"JobContactFax\":\"\",\"JobContactEmail\":\"\",\"IsSameAsJobContact\":true,\"BillingContactTitle\":\"Mr\",\"BillingContactFirstName\":\"aaa\",\"BillingContactLastName\":\"vvv\",\"BillingContactPhone\":\"15465656663\",\"BillingContactMobile\":\"\",\"BillingContactFax\":\"\",\"BillingContactEmail\":\"\",\"Memos\":\"\",\"JobAddress\":\"\",\"JobAddressLine2\":\"\",\"JobCity\":\"\",\"JobState\":\"\",\"JobPostalCode\":\"\",\"JobCountry\":\"Australia\",\"IsSameAsJobAddress\":true,\"BillingAddress\":\"\",\"BillingAddressLine2\":\"\",\"BillingCity\":\"\",\"BillingState\":\"\",\"BillingPostalCode\":\"\",\"BillingCountry\":\"Australia\",\"ABN\":\"\",\"DefaultSalesDiscount\":null,\"BSBNumber\":\"\",\"BankAccountNumber\":\"\",\"BankAccountName\":\"\",\"StatementText\":\"\",\"PaymentMemos\":\"\",\"DefaultSalesTaxCodeID\":\"f8399a46-c8a7-4b59-802e-12565c936282\",\"IsInactive\":false,\"CreateDate\":null,\"HasExportedToQ6\":null}}";
        string EditClientContent = "{\"CompanyValidateInfo\":{\"LoginName\":\"testapi@tasq.com.au\",\"ClientIP\":null,\"Password\":\"test123.\",\"MobileDeviceToken\":null,\"WebApiTOKEN\":\"b3b777b0-c7af-458d-be64-b3d6d760177f\"},\"Client\":{\"ClientID\":\"5f39d21b-4fcd-4c90-ae53-47d72e61d5b7\",\"ClientName\":\"AZ_1\",\"JobContactTitle\":\"Mr\",\"JobContactFirstName\":\"aaabb\",\"JobContactLastName\":\"vvv\",\"JobContactPhone\":\"15465656663\",\"JobContactMobile\":\"\",\"JobContactFax\":\"\",\"JobContactEmail\":\"\",\"IsSameAsJobContact\":true,\"BillingContactTitle\":\"Mr\",\"BillingContactFirstName\":\"aaabb\",\"BillingContactLastName\":\"vvv\",\"BillingContactPhone\":\"15465656663\",\"BillingContactMobile\":\"\",\"BillingContactFax\":\"\",\"BillingContactEmail\":\"\",\"Memos\":\"\",\"JobAddress\":\"\",\"JobAddressLine2\":\"\",\"JobCity\":\"\",\"JobState\":\"\",\"JobPostalCode\":\"\",\"JobCountry\":\"Australia\",\"IsSameAsJobAddress\":true,\"BillingAddress\":\"\",\"BillingAddressLine2\":\"\",\"BillingCity\":\"\",\"BillingState\":\"\",\"BillingPostalCode\":\"\",\"BillingCountry\":\"Australia\",\"ABN\":\"\",\"DefaultSalesDiscount\":null,\"BSBNumber\":\"\",\"BankAccountNumber\":\"\",\"BankAccountName\":\"\",\"StatementText\":\"\",\"PaymentMemos\":\"\",\"DefaultSalesTaxCodeID\":\"f8399a46-c8a7-4b59-802e-12565c936282\",\"IsInactive\":false,\"CreateDate\":null,\"HasExportedToQ6\":null}}";
        string DeleteClientContent = "{\"CompanyValidateInfo\":{\"LoginName\":\"testapi@tasq.com.au\",\"ClientIP\":null,\"Password\":\"test123.\",\"MobileDeviceToken\":null,\"WebApiTOKEN\":\"b3b777b0-c7af-458d-be64-b3d6d760177f\"},\"ID\":\"ea9f1308-fe33-4f58-b29e-0f6a3c58061a\",\"SendFromUserID\":null,\"NeedValidate\":false}";
        string ImportClientContent = "{\"CompanyValidateInfo\":{\"LoginName\":\"testapi@tasq.com.au\",\"ClientIP\":null,\"Password\":\"test123.\",\"MobileDeviceToken\":null,\"WebApiTOKEN\":\"b3b777b0-c7af-458d-be64-b3d6d760177f\"},\"ImportClientViewList\":[{\"ClientName\":\"testClient1\",\"JobContactTitle\":\"Mr\",\"JobContactFirstName\":\"testFirstName\",\"JobContactLastName\":\"testLastName\",\"JobContactPhone\":\"323243545\",\"JobContactFax\":\"323243545\",\"JobContactMobile\":\"411208787\",\"JobContactEmail\":\"test@testEmail.com\",\"IsSameAsJobContact\":\"YES\",\"BillingContactTitle\":\"\",\"BillingContactFirstName\":\"\",\"BillingContactLastName\":\"\",\"BillingContactPhone\":\"\",\"BillingContactMobile\":\"\",\"BillingContactEmail\":\"\",\"BillingContactFax\":\"\",\"Memos\":\"testMemo\",\"JobAddress\":\"7/30 ashted rd\",\"JobAddressLine2\":\"\",\"JobCity\":\"Box Hill\",\"JobState\":\"VIC\",\"JobPostalCode\":\"3128\",\"JobCountry\":\"Australia\",\"IsSameAsJobAddress\":\"YES\",\"BillingAddress\":\"\",\"BillingAddressLine2\":\"\",\"BillingCity\":\"\",\"BillingState\":\"\",\"BillingPostalCode\":\"\",\"BillingCountry\":\"\",\"ABN\":\"53 004 085 616\",\"DefaultSalesTaxCodeName\":\"GGGH\",\"DefaultSalesDiscount\":\"20\",\"BSBNumber\":\"123-456\",\"BankAccountNumber\":\"12345678\",\"BankAccountName\":\"testBankAccountName\",\"StatementText\":\"testStatementText\",\"PaymentMemo\":\"\"},{\"ClientName\":\"testClient2\",\"JobContactTitle\":\"Mr\",\"JobContactFirstName\":\"testFirstName\",\"JobContactLastName\":\"testLastName\",\"JobContactPhone\":\"323243545\",\"JobContactFax\":\"323243545\",\"JobContactMobile\":\"411208787\",\"JobContactEmail\":\"test@testEmail.com\",\"IsSameAsJobContact\":\"YES\",\"BillingContactTitle\":\"\",\"BillingContactFirstName\":\"\",\"BillingContactLastName\":\"\",\"BillingContactPhone\":\"\",\"BillingContactMobile\":\"\",\"BillingContactEmail\":\"\",\"BillingContactFax\":\"\",\"Memos\":\"testMemo\",\"JobAddress\":\"7/30 ashted rd\",\"JobAddressLine2\":\"\",\"JobCity\":\"Box Hill\",\"JobState\":\"VIC\",\"JobPostalCode\":\"3128\",\"JobCountry\":\"Australia\",\"IsSameAsJobAddress\":\"YES\",\"BillingAddress\":\"\",\"BillingAddressLine2\":\"\",\"BillingCity\":\"\",\"BillingState\":\"\",\"BillingPostalCode\":\"\",\"BillingCountry\":\"\",\"ABN\":\"53 004 085 616\",\"DefaultSalesTaxCodeName\":\"GGGH\",\"DefaultSalesDiscount\":\"20\",\"BSBNumber\":\"123-456\",\"BankAccountNumber\":\"12345678\",\"BankAccountName\":\"testBankAccountName\",\"StatementText\":\"testStatementText\",\"PaymentMemo\":\"\"}]}";





        protected void Page_Load(object sender, EventArgs e)
        {

        }


        public static string PostData(string Url, string content)
        {
            string result = "";
            HttpWebRequest req = (HttpWebRequest)WebRequest.Create(Url);
            req.Method = "POST";
            req.ContentType = "application/json";

            #region Add Post Param
            byte[] data = Encoding.UTF8.GetBytes(content);
            req.ContentLength = data.Length;
            using (Stream reqStream = req.GetRequestStream())
            {
                reqStream.Write(data, 0, data.Length);
                reqStream.Close();
            }
            #endregion

            HttpWebResponse resp = (HttpWebResponse)req.GetResponse();
            Stream stream = resp.GetResponseStream();
            using (StreamReader reader = new StreamReader(stream, Encoding.UTF8))
            {
                result = reader.ReadToEnd();
            }
            return result;
        }

        public static string GetData(string Url)
        {
            HttpWebRequest request = (HttpWebRequest)WebRequest.Create(Url);
            request.Method = "GET";
            request.ContentType = "application/json";

            HttpWebResponse response = (HttpWebResponse)request.GetResponse();
            Stream myResponseStream = response.GetResponseStream();
            StreamReader myStreamReader = new StreamReader(myResponseStream, Encoding.UTF8);
            string retString = myStreamReader.ReadToEnd();

            myStreamReader.Close();
            myResponseStream.Close();

            if (response != null)
            {
                response.Close();
            }
            if (request != null)
            {
                request.Abort();
            }

            return retString;
        }


        protected void btnCreateClient_Click(object sender, EventArgs e)
        {
            string strMessage = PostData(CreateClientUrl, CreateClientContent);

            json.InnerText = ConvertJsonString(strMessage);
        }

        protected void btnEditClient_Click(object sender, EventArgs e)
        {
            string strMessage = PostData(EditClientUrl, EditClientContent);

            json.InnerText = ConvertJsonString(strMessage);
        }

        protected void btnDeleteClient_Click(object sender, EventArgs e)
        {
            string strMessage = PostData(DeleteClientUrl, DeleteClientContent);

            json.InnerText = ConvertJsonString(strMessage);
        }

        protected void btnGetClientList_Click(object sender, EventArgs e)
        {
            string strMessage = GetData(GetClientListUrl);

            json.InnerText = ConvertJsonString(strMessage);

        }

        private string ConvertJsonString(string str)

        {

            //格式化json字符串

            JsonSerializer serializer = new JsonSerializer();

            TextReader tr = new StringReader(str);

            JsonTextReader jtr = new JsonTextReader(tr);

            object obj = serializer.Deserialize(jtr);

            if (obj != null)

            {

                StringWriter textWriter = new StringWriter();

                JsonTextWriter jsonWriter = new JsonTextWriter(textWriter)

                {

                    Formatting = Formatting.Indented,

                    Indentation = 4,

                    IndentChar = ' '

                };

                serializer.Serialize(jsonWriter, obj);

                return textWriter.ToString();

            }

            else

            {

                return str;

            }

        }

        protected void btnImportClient_Click(object sender, EventArgs e)
        {
            string strMessage = PostData(ImportClientUrl, ImportClientContent);
            json.InnerText = ConvertJsonString(strMessage);
        }
    }
}