﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Net;
using System.Text;
using System.IO;
using Newtonsoft.Json;

namespace CSharpSampleProject
{
    public partial class Job : System.Web.UI.Page
    {
        string CreateJobUrl = "https://jobapi.tasq.com.au/api/Job/CreateJob";
        string EditJobUrl = "https://jobapi.tasq.com.au/api/Job/EditJob";
        string DeleteJobUrl = "https://jobapi.tasq.com.au/api/Job/DeleteJob";
        string GetJobListUrl = "https://jobapi.tasq.com.au/api/Job/GetJobList?Jsonlogin={\"LoginName\":\"testapi%40tasq.com.au\",\"ClientIP\":null,\"Password\":\"test123.\",\"MobileDeviceToken\":null,\"WebApiTOKEN\":\"b3b777b0-c7af-458d-be64-b3d6d760177f\"}&Type=AllJobs&SearchText=&StartDate=2019-10-05&EndDate=2019-11-04&PageSize=26&PageIndex=1&IsJobCompletedType=AllJobs";

        string CreateJobContent = "{\"CompanyValidateInfo\":{\"LoginName\":\"testapi@tasq.com.au\",\"ClientIP\":null,\"Password\":\"test123.\",\"MobileDeviceToken\":null,\"WebApiTOKEN\":\"b3b777b0-c7af-458d-be64-b3d6d760177f\"},\"JobTransactionHeader\":{\"JobTransactionHeaderID\":null,\"ReferenceNo\":\"JOB00000030\",\"JobType\":\"Invoice\",\"JobStatus\":\"Open\",\"TransactionDate\":\"2019-11-04T12:54:58.905\",\"ClientID\":\"ea9f1308-fe33-4f58-b29e-0f6a3c58061a\",\"ClientPurchaseNo\":\"\",\"JobCategoryID\":null,\"HasApproval\":null,\"DueDate\":\"2020-11-30T00:00:00\",\"SubTotal\":null,\"TaxTotal\":null,\"TotalAmount\":null,\"Memo\":\"\",\"JobAddress\":\"ssssssss\",\"JobAddressLine2\":\"\",\"JobCity\":\"ddd\",\"JobState\":\"ACT\",\"JobPostalCode\":\"1234\",\"JobCountry\":\"Australia\",\"JobContactTitle\":\"Mr\",\"JobContactFirstName\":\"li\",\"JobContactLastName\":\"Ming\",\"JobContactPhone\":\"2222222244\",\"JobContactFax\":\"\",\"JobContactMobile\":\"\",\"JobContactEmail\":\"xiaofengxiong@uniware.com.au\",\"JobDescription\":\"\",\"IsSameAsJobAddress\":false,\"BillingAddress\":\"ssssssss\",\"BillingAddressLine2\":\"\",\"BillingCity\":\"ddd\",\"BillingState\":\"ACT\",\"BillingPostalCode\":\"1234\",\"BillingCountry\":\"Australia\",\"IsSameAsJobContact\":true,\"BillingContactTitle\":\"Mr\",\"BillingContactFirstName\":\"li\",\"BillingContactLastName\":\"Ming\",\"BillingContactPhone\":\"2222222244\",\"BillingContactFax\":\"\",\"BillingContactMobile\":\"\",\"BillingContactEmail\":\"xiaofengxiong@uniware.com.au\",\"BillingMemo\":\"\",\"IsCreatedByRecurring\":false,\"RecurringTemplateID\":null,\"HasLinkedDoc\":null,\"IsShowOnPDF\":false,\"TaxInclusive\":true,\"IsDeleted\":null,\"IsJobCompleted\":false,\"IsAuthorisedJob\":true,\"Createdby\":null,\"LastModifiedBy\":null,\"HasViewed\":null,\"CreateTime\":null,\"LastModifiedTime\":\"0001-01-01T00:00:00\",\"ClosedDate\":null,\"ClientName\":\"A_1\",\"DueDateRecurring\":null},\"JobTransactionDetail\":[],\"JobScheduleDateTime\":[],\"JobTasks\":[],\"JobRecordTime\":[],\"Note\":[],\"Photo\":[],\"ClientSignOff\":[],\"SendFromUserID\":null}";
        string EditJobContent = "{\"CompanyValidateInfo\":{\"LoginName\":\"testapi@tasq.com.au\",\"ClientIP\":null,\"Password\":\"test123.\",\"MobileDeviceToken\":null,\"WebApiTOKEN\":\"b3b777b0-c7af-458d-be64-b3d6d760177f\"},\"JobTransactionHeader\":{\"JobTransactionHeaderID\":\"3e609148-af19-49fc-a067-5bb4c3da67ad\",\"ReferenceNo\":\"JOB00000030\",\"JobType\":\"Invoice\",\"JobStatus\":\"Open\",\"TransactionDate\":\"2019-11-04T00:00:00\",\"ClientID\":\"ea9f1308-fe33-4f58-b29e-0f6a3c58061a\",\"ClientPurchaseNo\":\"\",\"JobCategoryID\":null,\"HasApproval\":null,\"DueDate\":\"2020-11-29T00:00:00\",\"SubTotal\":null,\"TaxTotal\":null,\"TotalAmount\":null,\"Memo\":\"\",\"JobAddress\":\"ssssssss\",\"JobAddressLine2\":\"\",\"JobCity\":\"ddd\",\"JobState\":\"ACT\",\"JobPostalCode\":\"1234\",\"JobCountry\":\"Australia\",\"JobContactTitle\":\"Mr\",\"JobContactFirstName\":\"li\",\"JobContactLastName\":\"Ming\",\"JobContactPhone\":\"2222222244\",\"JobContactFax\":\"\",\"JobContactMobile\":\"\",\"JobContactEmail\":\"xiaofengxiong@uniware.com.au\",\"JobDescription\":\"\",\"IsSameAsJobAddress\":false,\"BillingAddress\":\"ssssssss\",\"BillingAddressLine2\":\"\",\"BillingCity\":\"ddd\",\"BillingState\":\"ACT\",\"BillingPostalCode\":\"1234\",\"BillingCountry\":\"Australia\",\"IsSameAsJobContact\":true,\"BillingContactTitle\":\"Mr\",\"BillingContactFirstName\":\"li\",\"BillingContactLastName\":\"Ming\",\"BillingContactPhone\":\"2222222244\",\"BillingContactFax\":\"\",\"BillingContactMobile\":\"\",\"BillingContactEmail\":\"xiaofengxiong@uniware.com.au\",\"BillingMemo\":\"\",\"IsCreatedByRecurring\":false,\"RecurringTemplateID\":null,\"HasLinkedDoc\":null,\"IsShowOnPDF\":false,\"TaxInclusive\":true,\"IsDeleted\":null,\"IsJobCompleted\":false,\"IsAuthorisedJob\":true,\"Createdby\":null,\"LastModifiedBy\":null,\"HasViewed\":null,\"CreateTime\":null,\"LastModifiedTime\":\"2019-11-04T12:58:30\",\"ClosedDate\":null,\"ClientName\":\"A_1\",\"DueDateRecurring\":null},\"JobTransactionDetail\":[],\"JobScheduleDateTime\":[],\"JobTasks\":[],\"JobRecordTime\":[],\"Note\":[],\"Photo\":[],\"ClientSignOff\":[],\"SendFromUserID\":null}";
        string DeleteJobContent = "{\"CompanyValidateInfo\":{\"LoginName\":\"testapi@tasq.com.au\",\"ClientIP\":null,\"Password\":\"test123.\",\"MobileDeviceToken\":null,\"WebApiTOKEN\":\"b3b777b0-c7af-458d-be64-b3d6d760177f\"},\"ID\":\"3e609148-af19-49fc-a067-5bb4c3da67ad\",\"SendFromUserID\":null,\"NeedValidate\":true}";

        protected void Page_Load(object sender, EventArgs e)
        {

        }


        public static string PostData(string Url, string content)
        {
            string result = "";
            HttpWebRequest req = (HttpWebRequest)WebRequest.Create(Url);
            req.Method = "POST";
            req.ContentType = "application/json";

            #region Add Post Param
            byte[] data = Encoding.UTF8.GetBytes(content);
            req.ContentLength = data.Length;
            using (Stream reqStream = req.GetRequestStream())
            {
                reqStream.Write(data, 0, data.Length);
                reqStream.Close();
            }
            #endregion

            HttpWebResponse resp = (HttpWebResponse)req.GetResponse();
            Stream stream = resp.GetResponseStream();
            using (StreamReader reader = new StreamReader(stream, Encoding.UTF8))
            {
                result = reader.ReadToEnd();
            }
            return result;
        }

        public static string GetData(string Url)
        {
            HttpWebRequest request = (HttpWebRequest)WebRequest.Create(Url);
            request.Method = "GET";
            request.ContentType = "application/json";

            HttpWebResponse response = (HttpWebResponse)request.GetResponse();
            Stream myResponseStream = response.GetResponseStream();
            StreamReader myStreamReader = new StreamReader(myResponseStream, Encoding.UTF8);
            string retString = myStreamReader.ReadToEnd();

            myStreamReader.Close();
            myResponseStream.Close();

            if (response != null)
            {
                response.Close();
            }
            if (request != null)
            {
                request.Abort();
            }

            return retString;
        }


        protected void btnCreateJob_Click(object sender, EventArgs e)
        {
            string strMessage = PostData(CreateJobUrl, CreateJobContent);
            json.InnerText = ConvertJsonString(strMessage);
        }

        protected void btnEditJob_Click(object sender, EventArgs e)
        {
            string strMessage = PostData(EditJobUrl, EditJobContent);
            json.InnerText = ConvertJsonString(strMessage);
        }

        protected void btnDeleteJob_Click(object sender, EventArgs e)
        {
            string strMessage = PostData(DeleteJobUrl, DeleteJobContent);
            json.InnerText = ConvertJsonString(strMessage);
        }

        protected void btnGetJobList_Click(object sender, EventArgs e)
        {
            string strMessage = GetData(GetJobListUrl);
            json.InnerText = ConvertJsonString(strMessage);
        }

        private string ConvertJsonString(string str)

        {

            //格式化json字符串

            JsonSerializer serializer = new JsonSerializer();

            TextReader tr = new StringReader(str);

            JsonTextReader jtr = new JsonTextReader(tr);

            object obj = serializer.Deserialize(jtr);

            if (obj != null)

            {

                StringWriter textWriter = new StringWriter();

                JsonTextWriter jsonWriter = new JsonTextWriter(textWriter)

                {

                    Formatting = Formatting.Indented,

                    Indentation = 4,

                    IndentChar = ' '

                };

                serializer.Serialize(jsonWriter, obj);

                return textWriter.ToString();

            }

            else

            {

                return str;

            }

        }

    }
}