﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Net;
using System.Text;
using System.IO;
using Newtonsoft.Json;

namespace CSharpSampleProject
{
    public partial class Inventory : System.Web.UI.Page
    {
        string CreateInventoryUrl = "https://jobapi.tasq.com.au/api/Item/CreateInventory";
        string EditInventoryUrl = "https://jobapi.tasq.com.au/api/Item/EditInventory";
        string DeleteInventoryUrl = "https://jobapi.tasq.com.au/api/Item/DeleteInventory";
        string GetInventoryListUrl = "https://jobapi.tasq.com.au/api/Item/GetInventoryTreeList?Jsonlogin={\"LoginName\":\"testapi@tasq.com.au\",\"ClientIP\":null,\"Password\":\"test123.\",\"MobileDeviceToken\":null,\"WebApiTOKEN\":\"b3b777b0-c7af-458d-be64-b3d6d760177f\"}&Property=all&SearchText=&IsIncludeInactive=False&PageSize=33&PageIndex=1";
        string ImportInventoryUrl = "https://jobapi.tasq.com.au/api/Item/ImportInventory";

        string CreateInventoryContent = "{\"CompanyValidateInfo\":{\"LoginName\":\"testapi@tasq.com.au\",\"ClientIP\":null,\"Password\":\"test123.\",\"MobileDeviceToken\":null,\"WebApiTOKEN\":\"b3b777b0-c7af-458d-be64-b3d6d760177f\"},\"Inventory\":{\"InventoryID\":\"925c8266-728c-41cc-81c6-866674b844d4\",\"InventoryName\":\"Inventory1911041\",\"InventoryType\":\"Service\",\"SupplierPartNumber\":\"\",\"CategoryID\":null,\"PurchasePrice\":0.00,\"IsPurchasePriceTaxInclusive\":true,\"PurchaseTaxCodeID\":\"f8399a46-c8a7-4b59-802e-12565c936282\",\"SellingPrice\":0.00,\"IsSalePriceTaxInclusive\":true,\"SaleDescription\":\"\",\"SaleTaxCodeID\":\"f8399a46-c8a7-4b59-802e-12565c936282\",\"IsInventory\":false,\"IsInactive\":false,\"HasExportedToQ6\":null,\"IsRecordTimeTracking\":true,\"IsBuiltIn\":null,\"IsDefaultRecordTimeTracking\":false}}";
        string EditInventoryContent = "{\"CompanyValidateInfo\":{\"LoginName\":\"testapi@tasq.com.au\",\"ClientIP\":null,\"Password\":\"test123.\",\"MobileDeviceToken\":null,\"WebApiTOKEN\":\"b3b777b0-c7af-458d-be64-b3d6d760177f\"},\"Inventory\":{\"InventoryID\":\"925c8266-728c-41cc-81c6-866674b844d4\",\"InventoryName\":\"Inventory1911041\",\"InventoryType\":\"Service\",\"SupplierPartNumber\":\"\",\"CategoryID\":null,\"PurchasePrice\":0.00,\"IsPurchasePriceTaxInclusive\":true,\"PurchaseTaxCodeID\":\"f8399a46-c8a7-4b59-802e-12565c936282\",\"SellingPrice\":2.00,\"IsSalePriceTaxInclusive\":true,\"SaleDescription\":\"\",\"SaleTaxCodeID\":\"f8399a46-c8a7-4b59-802e-12565c936282\",\"IsInventory\":false,\"IsInactive\":false,\"HasExportedToQ6\":null,\"IsRecordTimeTracking\":true,\"IsBuiltIn\":null,\"IsDefaultRecordTimeTracking\":false}}";
        string DeleteInventoryContent = "{\"CompanyValidateInfo\":{\"LoginName\":\"testapi@tasq.com.au\",\"ClientIP\":null,\"Password\":\"test123.\",\"MobileDeviceToken\":null,\"WebApiTOKEN\":\"b3b777b0-c7af-458d-be64-b3d6d760177f\"},\"ID\":\"925c8266-728c-41cc-81c6-866674b844d4\",\"SendFromUserID\":null,\"NeedValidate\":false}";
        string ImportInventoryContent = "{\"CompanyValidateInfo\":{\"LoginName\":\"testapi@tasq.com.au\",\"ClientIP\":null,\"Password\":\"test123.\",\"MobileDeviceToken\":null,\"WebApiTOKEN\":\"b3b777b0-c7af-458d-be64-b3d6d760177f\"},\"ColumnList\":[\"*InventoryName\",\"*InventoryType\",\"IsInventoried\",\"SupplierPartNumber\",\"CategoryName\",\"BuyingPrice\",\"IsPurchasePriceTaxInclusive\",\"PurchaseTaxCodeName\",\"SellingPrice\",\"IsSalePriceTaxInclusive\",\"SaleDescription\",\"IsRecordTimeTracking\",\"IsDefaultRecordTimeTracking\"],\"ImportInventoryViewList\":[{\"InventoryName\":\"testInventory1\",\"InventoryType\":\"Inventory\",\"IsInventoried\":\"NO\",\"SupplierPartNumber\":\"123456\",\"CategoryName\":\"\",\"BuyingPrice\":\"$20.00 \",\"IsPurchasePriceTaxInclusive\":\"YES\",\"PurchaseTaxCodeName\":\"GGGH\",\"SellingPrice\":\"$30.00 \",\"IsSalePriceTaxInclusive\":\"YES\",\"SaleDescription\":\"testSaleDescription\",\"IsRecordTimeTracking\":\"NO\",\"IsDefaultRecordTimeTracking\":\"NO\"},{\"InventoryName\":\"testInventory2\",\"InventoryType\":\"Inventory\",\"IsInventoried\":\"NO\",\"SupplierPartNumber\":\"123456\",\"CategoryName\":\"\",\"BuyingPrice\":\"$20.00 \",\"IsPurchasePriceTaxInclusive\":\"YES\",\"PurchaseTaxCodeName\":\"GGGH\",\"SellingPrice\":\"$30.00 \",\"IsSalePriceTaxInclusive\":\"YES\",\"SaleDescription\":\"testSaleDescription\",\"IsRecordTimeTracking\":\"NO\",\"IsDefaultRecordTimeTracking\":\"NO\"},{\"InventoryName\":\"testInventory3\",\"InventoryType\":\"Inventory\",\"IsInventoried\":\"NO\",\"SupplierPartNumber\":\"123456\",\"CategoryName\":\"\",\"BuyingPrice\":\"$20.00 \",\"IsPurchasePriceTaxInclusive\":\"YES\",\"PurchaseTaxCodeName\":\"GGGH\",\"SellingPrice\":\"$30.00 \",\"IsSalePriceTaxInclusive\":\"YES\",\"SaleDescription\":\"testSaleDescription\",\"IsRecordTimeTracking\":\"NO\",\"IsDefaultRecordTimeTracking\":\"NO\"},{\"InventoryName\":\"testInventory4\",\"InventoryType\":\"Inventory\",\"IsInventoried\":\"NO\",\"SupplierPartNumber\":\"123456\",\"CategoryName\":\"\",\"BuyingPrice\":\"$20.00 \",\"IsPurchasePriceTaxInclusive\":\"YES\",\"PurchaseTaxCodeName\":\"GGGH\",\"SellingPrice\":\"$30.00 \",\"IsSalePriceTaxInclusive\":\"YES\",\"SaleDescription\":\"testSaleDescription\",\"IsRecordTimeTracking\":\"NO\",\"IsDefaultRecordTimeTracking\":\"NO\"}]}";

        protected void Page_Load(object sender, EventArgs e)
        {

        }

        public static string PostData(string Url, string content)
        {
            string result = "";
            HttpWebRequest req = (HttpWebRequest)WebRequest.Create(Url);
            req.Method = "POST";
            req.ContentType = "application/json";

            #region Add Post Param
            byte[] data = Encoding.UTF8.GetBytes(content);
            req.ContentLength = data.Length;
            using (Stream reqStream = req.GetRequestStream())
            {
                reqStream.Write(data, 0, data.Length);
                reqStream.Close();
            }
            #endregion

            HttpWebResponse resp = (HttpWebResponse)req.GetResponse();
            Stream stream = resp.GetResponseStream();
            using (StreamReader reader = new StreamReader(stream, Encoding.UTF8))
            {
                result = reader.ReadToEnd();
            }
            return result;
        }

        public static string GetData(string Url)
        {
            HttpWebRequest request = (HttpWebRequest)WebRequest.Create(Url);
            request.Method = "GET";
            request.ContentType = "application/json";

            HttpWebResponse response = (HttpWebResponse)request.GetResponse();
            Stream myResponseStream = response.GetResponseStream();
            StreamReader myStreamReader = new StreamReader(myResponseStream, Encoding.UTF8);
            string retString = myStreamReader.ReadToEnd();

            myStreamReader.Close();
            myResponseStream.Close();

            if (response != null)
            {
                response.Close();
            }
            if (request != null)
            {
                request.Abort();
            }

            return retString;
        }


        protected void btnCreateInventory_Click(object sender, EventArgs e)
        {
            string strMessage = PostData(CreateInventoryUrl, CreateInventoryContent);
            json.InnerText = ConvertJsonString(strMessage);
        }

        protected void btnEditInventory_Click(object sender, EventArgs e)
        {
            string strMessage = PostData(EditInventoryUrl, EditInventoryContent);
            json.InnerText = ConvertJsonString(strMessage);
        }

        protected void btnDeleteInventory_Click(object sender, EventArgs e)
        {
            string strMessage = PostData(DeleteInventoryUrl, DeleteInventoryContent);
            json.InnerText = ConvertJsonString(strMessage);
        }

        protected void btnGetInventoryList_Click(object sender, EventArgs e)
        {
            string strMessage = GetData(GetInventoryListUrl);
            json.InnerText = ConvertJsonString(strMessage);
        }

        protected void btnImportInventory_Click(object sender, EventArgs e)
        {
            string strMessage = PostData(ImportInventoryUrl, ImportInventoryContent);
            json.InnerText = ConvertJsonString(strMessage);
        }

        private string ConvertJsonString(string str)

        {

            //格式化json字符串

            JsonSerializer serializer = new JsonSerializer();

            TextReader tr = new StringReader(str);

            JsonTextReader jtr = new JsonTextReader(tr);

            object obj = serializer.Deserialize(jtr);

            if (obj != null)

            {

                StringWriter textWriter = new StringWriter();

                JsonTextWriter jsonWriter = new JsonTextWriter(textWriter)

                {

                    Formatting = Formatting.Indented,

                    Indentation = 4,

                    IndentChar = ' '

                };

                serializer.Serialize(jsonWriter, obj);

                return textWriter.ToString();

            }

            else

            {

                return str;

            }

        }

    }
}